#include "lpc824.h"

#include "serial.h"
void ConfigPins()
{
	GPIO_DIR0 |= BIT14; 
}
void delay(int len)
{
	while(len--);
}
void InitADC()
{
	// Will use Pin 1 (TSSOP-20 package) or PIO_23 for ADC
	// This corresponds to ADC Channel 3
	// Power up the ADC
	SYSCON_PDRUNCFG &= ~BIT4; 
	// Start the ADC Clocks
	SYSCON_SYSAHBCLKCTRL |= BIT24;
	// Ensure SEQA_ENA is disabled before making changes
	ADC_SEQA_CTRL &= ~BIT31;
	
	// Set the ADC Clock divisor
	ADC_CTRL =1;
	// Enable the ADC function on PIO_23
	SWM_PINENABLE0 &=~BIT16;
	// Select Channel 3
	ADC_SEQA_CTRL |= BIT3;
	// Set SEQA and Trigger polarity bits
	ADC_SEQA_CTRL |= BIT31 + BIT18;
	
}
int ReadADC()
{
	// Start a conversion:
	ADC_SEQA_CTRL |= BIT26;
	// Wait for data valid	
	while( (ADC_SEQA_GDAT & BIT31)==0); 
	return ( (ADC_SEQA_GDAT >> 4) & 0xfff);
}

void main()
{
	
	ConfigPins();	
	initUART();
	InitADC();
	enable_interrupts();
	printString("Start\n");
	while(1)	
	{
		GPIO_B14 = 1;
		delay(100000);		
		printHex(ReadADC());
		printString("\n");
		GPIO_B14 = 0;	
		delay(100000);	
	}
}
